#include  "soccer_agent_environment.h"
#include  "autogen_act_puppets.h"
#include  "autogen_act_puppets_sweeper.h"
#include  "autogen_act_puppets_coach.h"

using namespace std;

int    main( int  argc ,  char *  argv[] )
{
	//
	// Interpret Option
	//
	Soccer_Option_Analyser	opt( "SeVS-Puppets"  /* default team name */ ,
				     false  /* default is field player */ );

	if ( ! opt.analyse( argc , argv ) )
	{
		opt.usage();
		return( 1 );
	}
	else if ( opt.help() )
	{
		opt.usage();
		return( 0 );
	}


	//
	// Build Agent Environment
	//
	Soccer_Agent_Environment	agent_environment( opt );

	if ( ! agent_environment.valid() )
	{
		return( 1 );
	}


	//
	// Make Action
	//
	ref_count_ptr<Soccer_Action>	action;

	if ( opt.coach() )
	{
		action = new Act_Puppets_Coach
				( agent_environment.field_recog_interface() );
	}
	else if ( opt.role() == "Sweeper" )
	{
		action = new Act_Puppets_Sweeper
				( agent_environment.field_recog_interface() );
	}
	else
	{
		action = new Act_Puppets
				( agent_environment.field_recog_interface() ,
				  opt.role() );
	}

	if ( ! action )
	{
		cerr << "Can't allocate action!!" << endl;

		return( 1 );
	}


	//
	// Register Action
	//
	agent_environment.set_action( action );


	//
	// Main Loop
	//
	agent_environment.run();


	return( 0 );
}
