#include "d2_straight_line.h"
#include "field_predicate.h"

#include "player_set.h"

#include "autogen_act_single_hard_kick_to.h"

#include "my_conditions.h"

#include "player_select.h"

static   double n_step_dash_player( const Field_Recog_Interface & f ,
				    long n , double max_dash_power = -1.0 , double current_speed = 0.0 ) ;
static   double n_step_dash_player( const Field_Recog_Interface & f ,
				    long n , double max_dash_power , double current_speed )
{
	double	dash_power = 0.0 ;
	double	dist = 0.0 ;
	double	speed = 0.0 ;

	if ( n == 0 )
		return 0.0 ;

	if ( max_dash_power < 0.0 || max_dash_power > f.sserver_param().MAX_POWER() )
		dash_power = f.sserver_param().MAX_POWER() ;
	else
		dash_power = max_dash_power ;

	speed = current_speed ;
	if ( speed < 0.0 )
		speed= 0.0 ;
	else if ( speed > f.sserver_param().PLAYER_SPEED_MAX() )
		speed = f.sserver_param().PLAYER_SPEED_MAX() ;

	for ( long  t = 1  ; t <= n  ;  t ++ )
	{
		//t turnܤ˿ʤΥ 
		speed = speed * f.sserver_param().PLAYER_DECAY()
			+ f.sserver_param().dash_power_to_accel( dash_power ) ;
		
		if ( speed >= (f.sserver_param().PLAYER_SPEED_MAX()) - 1.0e-5 )
		{
			//祹ԡɤãޤ
			//ϤΥԡɤưޤ
			//ĤΥ * ԡ
			dist += f.sserver_param().PLAYER_SPEED_MAX() ;
			dist += f.sserver_param().PLAYER_SPEED_MAX() * (n-t) ;
			return dist ;
		}
		else
		{
			dist += speed ;
		}
	}

	return dist ;
	/* NOTREACHED */
}

//class PassSpace : public Field_Predicate
void	PassSpace::set_pass_check_type ( PassCheckType p ) 
{
	if ( this -> ptype != p )
	{
		this -> ptype = p ;
		check_time = -1 ;
	}
}
 
bool	PassSpace::check_pass_enable ( const Field_Recog_Interface & f ) const
{
	if ( f.current_time() != check_time )
	{
		calc_pass_point ( f ) ;
	}
	return pass_enable ;
}

D2_Vector	PassSpace::pass_point ( const Field_Recog_Interface & f ) const
{
	if ( f.current_time() != check_time )
	{
		calc_pass_point ( f ) ;
	}
	return target ;
}

PassSpace::PassCheckType	PassSpace::pass_type ( const Field_Recog_Interface & f ) const
{
	if ( f.current_time() != check_time )
	{
		calc_pass_point ( f ) ;
	}
	return ptype ;
}

//ѥФȤơïɤ줯餤ΥƥåפǼΤå롣
//̣trueʤfalse
//Angle Check
bool PassSpace::pass_receive_enable_teammate ( const Field_Recog_Interface & f , const Angle & pass_abs_angle ) const
{
	//ѥѥݥȤ˸ƽФȤơreceiverܡ뤫ɤ
	D2_Vector predict_ball_velocity ;
	predict_ball_velocity = Act_Single_Hard_Kick_To::result(f,pass_abs_angle) ;
	//predict_ball_velocity.set_r ( std::max(predict_ball_velocity.r(),2.3) ) ;

	D2_Vector ball_init_point = f.ball().coordinate() ;

	const int MAX_SEACH_STEP = 50 ;

	//Ȥꤢη׻̵
	int turn_step = 3 ;

	Player_Set	teammate_except_self
		= f.player_set( new And_Player_Predicate (new X_Range_Player_Predicate ( -52.5 , f.our_team().offence_line() ),
							  new And_Player_Predicate (new Teammate_Except_Self_Predicate,
										    new Coordinate_Accurate_Player_Predicate(-20)) )
				) ;

	if ( teammate_except_self.size() == 0 )
		return false ;

	Player_Set	all_player_except_self
		= f.player_set( new And_Player_Predicate (new All_Player_Except_Self_Predicate,
							  new Coordinate_Accurate_Player_Predicate(-20)) ) ;

	if ( dbg )
	{
		dbg <<"All Player Except Self :: " << all_player_except_self.size() << endl ;
	}

	for ( int t = 0 ; t < MAX_SEACH_STEP ; t ++ )
	{
		//ԥΥܡΰ
		D2_Vector ball_current_point
			= f.sserver_param().ball_basic_point_n_step_later(ball_init_point,predict_ball_velocity,t) ;

		//ܡ뤬fieldγ˹ԤäƤޤäΤʤ
		if ( fabs(ball_current_point.x()) > f.sserver_param().field_half_length() - 2.0
		     || fabs(ball_current_point.y()) > f.sserver_param().field_half_width() - 2.0 )
			return false ;

		//ԥǰưǽʵΥ
		//®ϤȤꤢ
		//D2_Vector player_movable_point
		//	= f.sserver_param().player_basic_point_n_step_later(D2_Vector(0,0),D2_Vector(0,0),t-turn_step) ;
		//D2_Vector player_movable_point ;
		//player_movable_point = D2_Vector ( n_step_dash_player( f ,(t-turn_step) ),0 ) ;

		double movable_distance = n_step_dash_player( f ,(t-turn_step) ) ;

		for ( Player_Set::iterator receiver=all_player_except_self.begin() ;
		      receiver != all_player_except_self.end(); ++ receiver )
		{
			if ( receiver -> coordinate().x() < f.self().coordinate().x() - 5.0 )
				continue ;

			D2_Vector buffer_distance ;
			if ( receiver -> side() == S_Side::Our_Side )
			{
				//ͥƥֻ׹(;͵򸫤)̣ϱ󤯤Ǥä
				buffer_distance.set_x(receiver->coordinate().accuracy_level() * 0.3) ;//-
			}
			else
			{
				//ͥƥֻ׹(;͵򸫤)Ũ϶äƤƤ
				buffer_distance.set_x((-receiver->coordinate().accuracy_level()) * 0.3) ;//+
			}

			double point_to_point_distance = (ball_current_point - receiver->coordinate() ).r() ;

			if ( point_to_point_distance < movable_distance + buffer_distance.r() )
			{
				if ( dbg )
				{
					dbg << "++++++++++++++++++++" << endl ;
					dbg << "Pass Receive!!!!!!!!" << endl ;
					dbg << "++++++++++++++++++++" << endl ;
				}
				if ( receiver -> side() == S_Side::Our_Side )
				{
					if ( dbg )
					{
						dbg << "Pass Receive Player Side : " << "Our Side" << endl ;
						dbg << "Pass enable" << endl ;
					}
				}
				else
				{
					if ( dbg )
					{
						dbg << "Pass Receive Player Side : " << "Opponent Side" << endl ;
						dbg << "Pass desable" << endl ;
					}
				}

				if ( dbg )
				{
					dbg << "Pass Receive Player Number" << receiver->player_number() << endl ;
					dbg << "Pass Receive Player Position" << receiver->coordinate() << endl ;
					dbg << "Pass Receive Point ("<< t << ") [" << ball_current_point << "]" << endl ;
					dbg << "Turn Step = " << turn_step << endl ; 
					dbg << "movable distance ("<< t << ") [" << movable_distance << "]" << endl ;
					dbg << "ball <--> receiver distance ("<< t << ") [" << point_to_point_distance << "]" << endl ;
				}

				if ( receiver -> side() == S_Side::Our_Side
				     && receiver->coordinate().x() < f.our_team().offence_line() )
				{
					tmp_target = ball_current_point ;
					return true ;
				}
				else
				{
					return false ;
				}
			}
		}
	}
	return false ;
}

//Pass Check (Coordinate)
bool PassSpace::pass_receive_enable_teammate ( const Field_Recog_Interface & f , const D2_Vector & pass_point ) const
{
	//ѥѥݥȤ˸ƽФȤơreceiverܡ뤫ɤ
	D2_Vector predict_ball_velocity ;
	predict_ball_velocity = Act_Single_Hard_Kick_To::result(f,pass_point) ;
	//predict_ball_velocity.set_r ( std::max(predict_ball_velocity.r(),2.3) ) ;

	D2_Vector ball_init_point = f.ball().coordinate() ;

	const int MAX_SEACH_STEP = 50 ;

	//Ȥꤢη׻̵
	//3󤯤餤Ϥ뤫ʡ
	int turn_step = 3 ;

	Player_Set	all_player_except_self
		= f.player_set( new And_Player_Predicate (new All_Player_Except_Self_Predicate,
							  new Coordinate_Accurate_Player_Predicate(-20)) ) ;

	if ( dbg )
	{
		dbg <<"All Player Except Self :: " << all_player_except_self.size() << endl ;
	}

	for ( int t = 1 ; t < MAX_SEACH_STEP ; t ++ )
	{
		//ԥΥܡΰ
		D2_Vector ball_current_point = f.sserver_param().ball_basic_point_n_step_later( ball_init_point,
												predict_ball_velocity,
												t ) ;
		//ܡ뤬fieldγ˹ԤäƤޤäΤʤ
		if ( fabs(ball_current_point.x()) > f.sserver_param().field_half_length() - 2.0
		     || fabs(ball_current_point.y()) > f.sserver_param().field_half_width() - 2.0 )
			return false ;

		//ԥǰưǽʵΥ
		//®ϤȤꤢ
		//D2_Vector player_movable_point = f.sserver_param().player_basic_point_n_step_later(D2_Vector(0,0),D2_Vector(0,0),t-turn_step) ;
		//D2_Vector player_movable_point ;
		//player_movable_point = D2_Vector ( n_step_dash_player( f ,(t-turn_step) ),0 ) ;
		//player_movable_point = D2_Vector ( f.sserver_param().PLAYER_SPEED_MAX()*(t-turn_step),0) ;

		double movable_distance = n_step_dash_player( f ,(t-turn_step) ) ;

		for ( Player_Set::iterator receiver=all_player_except_self.begin() ;
		      receiver != all_player_except_self.end(); ++ receiver )
		{
			if ( receiver -> coordinate().x() < f.self().coordinate().x() -5.0 )
				continue ;

			D2_Vector buffer_distance ;
			if ( receiver -> side() == S_Side::Our_Side )
			{
				//ͥƥֻ׹(;͵)̣ϱ󤯤Ǥä
				buffer_distance.set_x(receiver->coordinate().accuracy_level() * 0.3) ;
			}
			else
			{
				//ͥƥֻ׹(;͵)Ũ϶äƤƤ
				buffer_distance.set_x((-receiver->coordinate().accuracy_level()) * 0.3) ;
			}

			double point_to_point_distance = (ball_current_point - receiver->coordinate() ).r() ;

			if ( point_to_point_distance < movable_distance + buffer_distance.r() )
			{
				if ( dbg )
				{
					dbg << "++++++++++++++++++++" << endl ;
					dbg << "Pass Receive!!!!!!!!" << endl ;
					dbg << "++++++++++++++++++++" << endl ;
				}
				if ( receiver -> side() == S_Side::Our_Side )
				{
					if ( dbg )
					{
						dbg << "Pass Receive Player Side : " << "Our Side" << endl ;
						dbg << "Pass enable" << endl ;
					}
				}
				else
				{
					if ( dbg )
					{
						dbg << "Pass Receive Player Side : " << "Opponent Side" << endl ;
						dbg << "Pass desable" << endl ;
					}
				}

					if ( dbg )
					{
						dbg << "Pass Receive Player Number" << receiver->player_number() << endl ;
						dbg << "Pass Receive Player Position" << receiver->coordinate() << endl ;
						dbg << "Pass Receive Point ("<< t << ") [" << ball_current_point << "]" << endl ;
						dbg << "Turn Step = " << turn_step << endl ; 
						dbg << "movable distance ("<< t << ") [" << movable_distance << "]" << endl ;
						dbg << "ball <--> receiver distance ("<< t << ") [" << point_to_point_distance << "]" << endl ;
					}

				if ( receiver -> side() == S_Side::Our_Side
				     && receiver->coordinate().x() < f.our_team().offence_line() )
				{
					tmp_target = ball_current_point ;
					return true ;
				}
				else
				{
					return false ;
				}
			}
		}
	}
	return false ;
}


void	PassSpace::calc_pass_point ( const Field_Recog_Interface & f ) const
{
	if ( ptype == Angle_Check )
	{
		calc_pass_point_angle ( f ) ;
	}
	else if ( ptype == Coordinate_Check )
	{
		calc_pass_point_vector ( f ) ;
	}
}

void	PassSpace::calc_pass_point_angle ( const Field_Recog_Interface & f ) const
{
	D2_Vector best_point ;
	double	best_angle = -1000 ;
	Angle	min_angle,max_angle ;
	Angle	angle_lower,angle_upper;
	Angle	div_angle ;

	int	check_angle_num = 0 ;
	min_angle = Degree(-180) ;
	max_angle = Degree(+180) ;
	div_angle = Degree(5.0) ;

	//ʬξˤäõϰϤѤ
	if ( f.self().coordinate().x() < -20.0 )//ؿʤ
	{
		//
		//(/90 5) 18
		angle_lower = Degree(-45.0) ;
		angle_upper = Degree(45.0) ;
		div_angle = Degree(5.0) ;
	}
	else if ( f.self().coordinate().x() < 0.0 )//ؤʤ
	{
		//(/ 120 7) 17.142857142857142
		angle_lower = Degree(-60.0) ;
		angle_upper = Degree(60.0) ;
		div_angle = Degree(7.0) ;
	}
	else if ( f.self().coordinate().x() > 36.0 && fabs(f.self().coordinate().y()) > 20.0 )
	{
		//(/ 130.0 7.0) 18.571428571428573
		if ( f.self().coordinate().y() > 0.0 )
		{
			angle_lower = Degree(-100.0) ;
			angle_upper = Degree(30.0) ;
		}
		else
		{
			angle_lower = Degree(-30.0) ;
			angle_upper = Degree(100.0) ;
		}
		div_angle = Degree(7.0) ;
	}
	else if ( f.self().coordinate().x() > 36.0 && fabs(f.self().coordinate().y()) < 20.0 )
	{
		//(/ 170 9) 
		angle_lower = Degree(-85.0) ;
		angle_upper = Degree(85.0) ;
		div_angle = Degree(9.0) ;
	}
	else
	{
		//(/ 120 10) 15
		angle_lower = Degree(-60.0) ;
		angle_upper = Degree(60.0) ;
		div_angle = Degree(8.0) ;
	}

	if ( angle_lower < min_angle )
		angle_lower = min_angle ;
	if ( angle_upper > max_angle )
		angle_upper = max_angle ;

	//test
#if 0
	angle_lower = Degree(-60.0) ;
	angle_upper = Degree(60.0) ;
	div_angle   = Degree(30.0) ;
#endif
	for ( Angle th = angle_lower ; th < angle_upper ; th += div_angle )
	{
		Pass_Ratio_Check	pcheck ;
		D2_Vector	pass_check_point (D2_Vector::Pole,f.sserver_param().field_diagonal_length(),th) ;
		double min_pass_angle = pcheck.pass_check_angle3(f,f.ball().coordinate(),pass_check_point) ;

		check_angle_num ++ ;
		if ( pass_receive_enable_teammate ( f , th ) == true )
		{
			if ( dbg )
			{
				dbg << " Set Temporaly Pass Target !" << endl ;
			}
			if ( best_angle <= min_pass_angle )
			{
				if ( dbg )
				{
					dbg << "Update Best angle " << pass_check_point
					    << "angle(" << min_pass_angle << ")" << endl ;
				}
				best_angle = min_pass_angle ;
				best_point = pass_check_point ;
				best_point = tmp_target ;
			}
		}
	}

	if ( dbg ){
		dbg << "Number Of Pass Space Check : " << check_angle_num << endl ;
	}
	if ( best_angle < 10.0 )
	{
		pass_enable = false ;
		check_time = f.current_time() ;
	}
	else
	{
		pass_enable = true ;
		target = best_point ;
		check_time = f.current_time() ;
		if ( dbg )
		{
			dbg << "-------------------------------------------------" << endl ;
			dbg << "Time = " << check_time.main_step() << endl ;
			dbg << "Best Pass Point = " << best_point << endl ;
			dbg << "-------------------------------------------------" << endl ;
		}
	}
}

void	PassSpace::calc_pass_point_vector ( const Field_Recog_Interface & f ) const
{
	//ݥȤФƥѥФΤĴ٤롣
	//ڡ򸫤Ĥ
	//ŤΤǤäѹ

	D2_Vector best_point ;
	double	  best_angle = -1000 ;
	double	min_x,max_x,min_y,max_y ;

	double	div_x = 6.0 ;
	double	div_y = 6.0 ;

	double x_lower =0, y_lower =0, x_upper =0, y_upper =0;

	min_x = f.self().coordinate().x() + 10.0 ;
	max_x = f.sserver_param().field_half_length() - 15.0 ;
	min_y = -f.sserver_param().field_half_width() + 10.0 ;
	max_y = f.sserver_param().field_half_width() - 10.0 ;

	//ʬξˤäõϰϤѤ
	if ( f.self().coordinate().x() < -20.0 )//ؿʤ
	{
		x_upper = f.self().coordinate().x() + 25.0 ;
		x_lower = min_x;
		div_x = 10.0 ; 
	}
	else if ( f.self().coordinate().x() < 0.0 )//ؤʤ
	{
		x_upper = f.self().coordinate().x() + 25.0 ;
		x_lower = min_x;
	}
	else
	{
		x_upper = f.self().coordinate().x() + 30.0 ;
		x_lower = f.self().coordinate().x() + 10.0 ;
	}
		
	y_upper = f.self().coordinate().y() + 15.0 ;
	y_lower = f.self().coordinate().y() - 15.0 ;

	if ( x_lower <= min_x )
		x_lower = min_x ;
	if ( y_lower <= min_y )
		y_lower = min_y ;
	if ( x_upper >= max_x )
		x_upper = max_x ;
	if ( y_upper >= max_y )
		y_upper = max_y ;

	for ( double x = x_upper ; x > x_lower ; x -= div_x )
	{
		for ( double y = y_lower ; y < y_upper ; y += div_y )
		{
			Pass_Ratio_Check	pcheck ;
			pcheck.set_pass_type(Pass_Ratio_Check::Type_Forward) ;
			D2_Vector pass_check_point(x,y) ;

			if ( (f.ball().coordinate() - pass_check_point ).r() > f.sserver_param().field_half_length()*0.8
			     || (f.ball().coordinate() - pass_check_point).r() < 5.0 )
			{
				continue ;
			}

			if ( pcheck.pass_check_type ( f,pass_check_point , Pass_Ratio_Check::Type_Forward )
			     && pcheck.pass_check_danger ( f,pass_check_point ) )
			{
				double min_pass_angle = pcheck.pass_check_angle3(f,f.ball().coordinate(),pass_check_point) ;
				if ( pass_receive_enable_teammate ( f , pass_check_point ) == true )
				{
					if ( dbg )
					{
						dbg << " Set Temporaly Pass Target !" << endl ;
					}
					if ( best_angle <= min_pass_angle )
					{
						if ( dbg )
						{
							dbg << "Update Best angle " << pass_check_point
							    << "angle(" << min_pass_angle << ")" << endl ;
						}
						best_angle = min_pass_angle ;
						best_point = pass_check_point ;
						tmp_target  = best_point ;
					}
				}
			}
		}
	}

	if ( best_angle < 10.0 )
	{
		pass_enable = false ;
		check_time = f.current_time() ;
	}
	else
	{
		pass_enable = true ;
		target = best_point ;
		check_time = f.current_time() ;
		if ( dbg )
		{
			dbg << "-------------------------------------------------" << endl ;
			dbg << "Time = " << check_time.main_step() << endl ;
			dbg << "Best Pass Point = " << best_point << endl ;
			dbg << "-------------------------------------------------" << endl ;
		}
	}
}


////////////////////////////////////////////////////////////////////////
//	Pass Ratio Check
//	class Pass_Ratio_Check
////////////////////////////////////////////////////////////////////////

Pass_Ratio_Check::Pass_Ratio_Check ( Pass_Type set_type )
	:ptype(set_type)
{
	set_unum_time = -1 ;
	pass_unum = -1 ;
}

void Pass_Ratio_Check::set_pass_type ( Pass_Type set_type )
{
	if ( ptype != set_type )
	{
		ptype = set_type ;
		set_unum_time = -1 ;
		pass_unum = -1 ;
	}
}

void Pass_Ratio_Check::set_pass_unum ( const Field_Recog_Interface & f,const int i ) const
{
	//calc pass teammate
	pass_unum = i ;
	set_unum_time = f.current_time() ;
}

int Pass_Ratio_Check::get_pass_unum ( const Field_Recog_Interface & f ) const
{
	if ( this -> set_unum_time == f.current_time() )
	{
		//cache
	}
	else
	{
		//calc pass teammate
		set_pass_unum ( f,get_pass_teammate_unum (f) ) ;
	}
	return pass_unum ;
}

int Pass_Ratio_Check::get_pass_teammate_unum ( const Field_Recog_Interface & f ) const
{
	if ( dbg )
	{
		dbg << "my coordinate (" << f.self().coordinate().x() << " , " << f.self().coordinate().y() << ")" << endl;
	}
	for ( double r = 0.8 ; r > 0.2 ; r -= 0.1 )
	{
		for ( int i = 1 ; i <= MAX_PLAYER ; ++ i )
		{
			if ( f.teammate(i).self_player() ) continue ;
			if ( f.teammate(i).goalie() ) continue ;

			if ( f.teammate(i).coordinate().accuracy_check(-10) )
			{
				if ( dbg )
				{
					dbg << "   Pass ? ("<<	i << ")("
					    << f.teammate(i).coordinate()
					    << "),("
					    << f.teammate(i).coordinate().accuracy_level()
					    << ")" << endl ;
				}

				//offside check
				if ( f.our_team().offence_line() > f.teammate(i).coordinate().x() )
				{
					//pass check
					//angle check
					//if ( pass_check_angle ( f,f.teammate(i).coordinate() , r ) )
					//if ( pass_check_angle2 ( f,f.teammate(i).coordinate() , r ) )
					if ( pass_check_angle3(f,f.ball().coordinate(),f.teammate(i).coordinate()) >= atan(r) * 180 / 3.1415 )
					{
						//type check
						if ( pass_check_type ( f,f.teammate(i).coordinate() , this->ptype )
						     &&
						     ( f.teammate(i).coordinate().x() > f.self().coordinate().x() - 5 )
						     &&
						     ( (f.teammate(i).coordinate() - f.self().coordinate()).r() < 25.0 )
#if 0
						     &&
						     //temporary
						     pass_check_type ( f,f.teammate(i).coordinate() , Type_Forward )
#endif
						     )
						{
							if ( pass_check_danger ( f,f.teammate(i).coordinate() ) )
							{
								if ( dbg )
								{
									dbg << "   Pass To ("<<	i << "),("
									    << f.teammate(i).coordinate().accuracy_level()
									    << "),(" 
									    << "Ratio " << r
									    << ")" 
									    << "Coordinate(" << f.teammate(i).coordinate().x() << " , " << f.teammate(i).coordinate().y() << ")"
									    << endl ;
								}
								return i;
							}
						}
					}
				}
			}
		}
	}
	return -1 ;
}

double  Pass_Ratio_Check::pass_check_angle3( const Field_Recog_Interface &  f ,
			   const D2_Vector &  from , const D2_Vector &  to ) const
{
	Angle	check_dir = (to-from).theta().normalize();
	Angle	pass_cource_angle = Degree( + 360.0 );

	for ( int  i = 1  ;  i <= MAX_PLAYER  ;  i ++ )
	{
		Player_Reference	player = f.opponent(i);

		if ( ! player.coordinate().accuracy_check( -10 ) ) continue;
		if ( (player.coordinate()-from).r() > (to-from).r() + 1.0) continue;

		Angle	angle_diff
			= ((player.coordinate()-from).theta()-check_dir).normalize().abs();

		Radian	kickable_angle ( asin ( min( f.sserver_param().kickable_distance()
						     / (player.coordinate()-from).r() ,1.0 ) ) ) ;
		angle_diff = max( angle_diff - kickable_angle , Angle::origin() ) ;

		if ( pass_cource_angle > angle_diff )
		{
			pass_cource_angle = angle_diff;
		}
	}

	for ( size_t  i = 0  ;  i < f.n_unknown_opponent()  ;  i ++ )
	{
		Player_Reference	player = f.unknown_opponent(i);

		if ( ! player.coordinate().accuracy_check( -10 ) ) continue;
		if ( (player.coordinate()-from).r() > (to-from).r() + 1.0) continue;

		Angle	angle_diff
			= ((player.coordinate()-from).theta()-check_dir).normalize().abs();

		Radian	kickable_angle ( asin ( min( f.sserver_param().kickable_distance()
						     / (player.coordinate()-from).r() ,1.0 ) ) ) ;
		angle_diff = max( angle_diff - kickable_angle , Angle::origin() ) ;

		if ( pass_cource_angle > angle_diff )
		{
			pass_cource_angle = angle_diff;
		}
	}

	for ( size_t  i = 0  ;  i < f.n_unknown_player()  ;  i ++ )
	{
		Player_Reference	player = f.unknown_player(i);

		if ( ! player.coordinate().accuracy_check( -10 ) ) continue;
		if ( (player.coordinate()-from).r() > (to-from).r() + 1.0) continue;

		Angle	angle_diff
			= ((player.coordinate()-from).theta()-check_dir).normalize().abs();

		Radian	kickable_angle ( asin ( min( f.sserver_param().kickable_distance()
						     / (player.coordinate()-from).r() ,1.0 ) ) ) ;
		angle_diff = max( angle_diff - kickable_angle , Angle::origin() ) ;

		if ( pass_cource_angle > angle_diff )
		{
			pass_cource_angle = angle_diff;
		}
	}

	return( pass_cource_angle.normalize().degree() ) ;
}


bool Pass_Ratio_Check::pass_check_angle2 ( const Field_Recog_Interface & f,const D2_Vector & target , double ratio ) const
{
	//ȣrܦȣ
	//ȣarctan(
	//ʤȤ򤢤魯
	//ȣarcsinʣ/
	//(kickable_area(¤礭)*cos(ȣ
	//ŨȤεΥ

	double theta_r = atan(ratio) ;
	double h = (f.sserver_param().kickable_distance() -0.05 ) * cos ( theta_r ) ;

	// angle check2
	D2_Straight_Line l( f.ball().coordinate() , target ) ;
	D2_Vector proj_pt ;
	D2_Vector pt ;

	try
	{
		proj_pt = l.project_point(target) ;
	}
	catch (D2_Region::No_Region_Error)
	{
		proj_pt = target ;
	}

	for ( int i = 1 ; i <= MAX_PLAYER ; ++ i )
	{
		if ( f.opponent(i).coordinate().accuracy_check(-10) )
		{
			pt = f.opponent(i).coordinate() ;
		}
		else
		{
			continue ;
		}

		double theta_c = asin ( h / (f.ball().coordinate() - pt).r() ) ;
		double theta = theta_r + theta_c ;

		double true_alpha = tan(theta) ;

		if ( (proj_pt - pt).r() < (proj_pt - f.ball().coordinate()).r() * true_alpha * true_alpha )
		{
			double dist2 = (f.ball().coordinate() - target).r() ;
			if ( (proj_pt-target).r() <= dist2 && (proj_pt-f.ball().coordinate()).r() <= dist2 )
			{
				return false ;
			}
			else
			{
				continue ;
			}
		}
		else
		{
			continue ;
		}
	}

	for ( size_t i = 0 ; i < f.n_unknown_opponent() ; ++ i )
	{
		if ( f.unknown_opponent(i).coordinate().accuracy_check(-10) )
		{
			pt = f.unknown_opponent(i).coordinate() ;
		}
		else
		{
			continue ;
		}

		double theta_c = asin ( h / (f.ball().coordinate() - pt).r() ) ;
		double theta = theta_r + theta_c ;

		double true_alpha = tan(theta) ;

		if ( (proj_pt - pt).r() < (proj_pt - f.ball().coordinate()).r() * true_alpha * true_alpha )
		{
			double dist2 = (f.ball().coordinate() - target).r() ;
			if ( (proj_pt-target).r() <= dist2 && (proj_pt-f.ball().coordinate()).r() <= dist2 )
			{
				return false ;
			}
			else
			{
				continue ;
			}
		}
		else
		{
			continue ;
		}
	}

	for ( size_t i = 0 ; i < f.n_unknown_player() ; ++ i )
	{
		if ( f.unknown_player(i).coordinate().accuracy_check(-10) )
		{
			pt = f.unknown_player(i).coordinate() ;
		}
		else
		{
			continue ;
		}

		double theta_c = asin ( h / (f.ball().coordinate() - pt).r() ) ;
		double theta = theta_r + theta_c ;

		double true_alpha = tan(theta) ;

		if ( (proj_pt - pt).r() < (proj_pt - f.ball().coordinate()).r() * true_alpha * true_alpha )
		{
			double dist2 = (f.ball().coordinate() - target).r() ;
			if ( (proj_pt-target).r() <= dist2 && (proj_pt-f.ball().coordinate()).r() <= dist2 )
			{
				return false ;
			}
			else
			{
				continue ;
			}
		}
		else
		{
			continue ;
		}
	}

	return true ;
}

bool Pass_Ratio_Check::pass_check_angle ( const Field_Recog_Interface & f,const D2_Vector & target , double ratio ) const
{
	// angle check
	D2_Straight_Line l( f.ball().coordinate() , target ) ;
	D2_Vector proj_pt ;
	D2_Vector pt ;

	try
	{
		proj_pt = l.project_point(target) ;
	}
	catch (D2_Region::No_Region_Error)
	{
		proj_pt = target ;
	}

	for ( int i = 1 ; i <= MAX_PLAYER ; ++ i )
	{
		if ( f.opponent(i).coordinate().accuracy_check(-10) )
		{
			pt = f.opponent(i).coordinate() ;
		}
		else
		{
			continue ;
		}

		if ( (proj_pt - pt).r() < (proj_pt - f.ball().coordinate()).r() * ratio* ratio )
		{
			double dist2 = (f.ball().coordinate() - target).r() ;
			if ( (proj_pt-target).r() <= dist2 && (proj_pt-f.ball().coordinate()).r() <= dist2 )
			{
				return false ;
			}
			else
			{
				continue ;
			}
		}
		else
		{
			continue ;
		}
	}


	for ( size_t i = 0 ; i < f.n_unknown_opponent() ; ++ i )
	{
		if ( f.unknown_opponent(i).coordinate().accuracy_check(-10) )
		{
			pt = f.unknown_opponent(i).coordinate() ;
		}
		else
		{
			continue ;
		}

		if ( (proj_pt - pt).r() < (proj_pt - f.ball().coordinate()).r() * ratio* ratio )
		{
			double dist2 = (f.ball().coordinate() - target).r() ;
			if ( (proj_pt-target).r() <= dist2 && (proj_pt-f.ball().coordinate()).r() <= dist2 )
			{
				return false ;
			}
			else
			{
				continue ;
			}
		}
		else
		{
			continue ;
		}
	}

	return true ;
}

//centering? penalty area?
bool Pass_Ratio_Check::pass_check_danger ( const Field_Recog_Interface & f,const D2_Vector & target ) const
{
	//pass point check

	//target is in own penalty area
	if ( target.x() <=
	     - f.sserver_param().field_half_length() + f.sserver_param().penalty_area_length() + 2.0
	     &&
	     ( fabs ( target.y() )
	       <= f.sserver_param().penalty_area_half_width() + 2.0 ) )
	{
		return false ;
	}

	if ( f.ball().coordinate().x() < -32.0
	     &&
	     ( fabs(target.y()) <= 23.0 && fabs(f.ball().coordinate().y()) >= 24.0 )
	     )
	{
		return false ;
	}

	return true ;
}

bool Pass_Ratio_Check::pass_check_type ( const Field_Recog_Interface & f,const D2_Vector & target , Pass_Type pass_type ) const
{
	//temporary
	const double CENTER_Y = 16.0 ;
	const double SIDE_Y = 18.0 ;
	const double LSIDE_Y = -18.0 ;
	const double RSIDE_Y = 18.0 ;
	const double FARDIST = 30.0 ;
	const double NEARDIST = 10.0 ;

	// pass type check
	if ( pass_type == Type_None )
	{
		return true ;
	}
	else if ( pass_type == Type_Center )
	{
		//if ( fabs(f.self().coordinate().y()) > fabs(target.y() ))
		//return true ;
		if ( fabs (target.y() ) < CENTER_Y )
			return true ;
		else
			return false ;
	}
	else if ( pass_type == Type_Side )
	{
		if ( fabs (target.y() ) > SIDE_Y )
			return true ;
		else
			return false ;
	}
	else if ( pass_type == Type_Forward )
	{
		if ( target.x() -5.0 > f.self().coordinate().x() )
			return true ;
		else
			return false ;
	}
	else if ( pass_type == Type_Backward )
	{
		if ( target.x() < f.self().coordinate().x() -5.0 )
			return true ;
		else
			return false ;
	}
	else if ( pass_type == Type_Rside )
	{
		if ( target.y() > RSIDE_Y )
			return true ;
		else
			return false ;
	}
	else if ( pass_type == Type_Lside )
	{
		if ( target.y() < LSIDE_Y )
			return true ;
		else
			return false ;
	}
	else if ( pass_type == Type_Ownside )
	{
		if ( f.self().coordinate().y() > 0 && target.y() > 0 )
			return true ;
		else if ( f.self().coordinate().y() < 0 && target.y() < 0 )
			return true ;
		else
			return false ;
	}
	else if ( pass_type == Type_Near )
	{
		if ( (f.self().coordinate() - target ).r() < NEARDIST )
			return true ;
		else
			return false ;
	}
	else if ( pass_type == Type_Far )
	{
		if ( (f.self().coordinate() - target ).r() > FARDIST )
			return true ;
		else
			return false ;
	}
	else
	{
		//Error
		// unrecognize type
		return false ;
	}

}

bool Pass_Ratio_Check::pass_finished ( const Field_Recog_Interface & f ) const
{
	if ( ! f.ball().coordinate().accuracy_check( -10 ) )
		return true ;

	if ( (f.ball().coordinate() - f.self().coordinate()).r()
	     > f.sserver_param().kickable_distance() - 0.05 )
		return true ;

	return false ;
}
