#ifndef	   CONSERVATIVE_PASS_COURCE_TABLE_H_INCLUDED
#define	   CONSERVATIVE_PASS_COURCE_TABLE_H_INCLUDED

// Author:		H. Shimora
// Created:		Jul 27 2001
// Version:		0.00

///-----------------------------------------------
/// Change Log:
///-----------------------------------------------
// version 0.00  Jul 27 2001    base version.
//
//

#include  "pass_cource_table.h"
#include  "autogen_act_shoot.h"

class  Conservative_Pass_Cource_Table : public Pass_Cource_Table
{
public:
		 Conservative_Pass_Cource_Table() {}
	virtual	~Conservative_Pass_Cource_Table(){}

	virtual	bool	shoot_check( const Field_Recog_Interface &  f ,
				     const Player_Reference &  from ) const
	{
		const	long	VALID_TEAMMATE_ACCURACY = - 40;
		const	long	VALID_OPPONENT_ACCURACY = - 40;
		const	long	VALID_FAR_OPPONENT_ACCURACY = - 200;

		if ( ! from.coordinate()
		     .accuracy_check( VALID_TEAMMATE_ACCURACY ) )
		{
			return( false );
		}

		if ( (from.coordinate()
		      - D2_Vector( f.sserver_param().field_half_length() ,
				   0.0 )).r()
		     > 34.0 )
		{
			return( false );
		}


		long	acc = VALID_OPPONENT_ACCURACY;

		if ( from.coordinate().x() <= 30.0 )
		{
			acc = VALID_FAR_OPPONENT_ACCURACY;
		}

		if ( from.self_player() )
		{
			return( Act_Shoot::free_angle( f , acc )
				>= Degree( 30.0 ) );
		}
		else
		{
			return( Act_Shoot::free_angle( f , acc )
				>= Degree( 20.0 ) );
		}
	}
};


#endif	/* CONSERVATIVE_PASS_COURCE_TABLE_H_INCLUDED */
