#include  "soccer_agent_environment.h"
#include  "autogen_act_neko.h"

using namespace std;

int    main( int  argc ,  char *  argv[] )
{
	//
	// Interpret Option
	//
	Soccer_Option_Analyser	opt( "Zeng00" /* default team name */ ,
				     false    /* default is field player */ );

	if ( ! opt.analyse( argc , argv ) )
	{
		opt.usage();
		return( 1 );
	}
	else if ( opt.help() )
	{
		opt.usage();
		return( 0 );
	}


	//
	// Build Agent Environment
	//
	Soccer_Agent_Environment	agent_environment( opt );

	if ( ! agent_environment.valid() )
	{
		return( 1 );
	}


	//
	// Make Action
	//
	Act_Neko::Role_Type	role;
	if ( opt.role() == "+FW" )
	{
		role = Act_Neko::Positive_Side_FW;
	}
	else if ( opt.role() == "-FW" )
	{
		role = Act_Neko::Negative_Side_FW;
	}
	else if ( opt.role() == "FW" || opt.role().length() == 0 )
	{
		role = Act_Neko::Zero_FW;
	}
	else
	{
		cerr << "Unrecognized Role: \"" << opt.role() << "\""
		     << endl;

		return( 1 );
	}

	ref_count_ptr<Soccer_Action>	action;

	action = new Act_Neko( agent_environment.field_recog_interface() ,
			       role );


	//
	// Register Action
	//
	agent_environment.set_action( action );


	//
	// Main Loop
	//
	agent_environment.run();


	return( 0 );
}
